Ӧ
======================

Ӧ [λ](concept-service-locator.md)һṩֲͬܵ *Ӧ* 
磬`urlManager`ҳ·ɵӦĿ`db`ṩݿطȵȡ

ͬһӦУÿӦһһ޶ ID Ӧͨ±ʽӦ
Each application component has an ID that uniquely identifies itself among other application components
in the same application. You can access an application component through the expression

```php
\Yii::$app->componentID
```

磬ʹ `\Yii::$app->db` ȡעᵽӦõ [[yii\db\Connection|DB connection]]
ʹ `\Yii::$app->cache` ȡעᵽӦõ [[yii\caching\Cache|primary cache]] 
and `\Yii::$app->cache` to get the [[yii\caching\Cache|primary cache]] registered with the application.
For example, you can use `\Yii::$app->db` to get the [[yii\db\Connection|DB connection]],
and `\Yii::$app->cache` to get the [[yii\caching\Cache|primary cache]] registered with the application.

һʹϱʽʱᴴӦʵٷʻ᷵شʵٴδ
An application component is created the first time it is accessed through the above expression. Any
further accesses will return the same component instance.

Ӧ󣬿 [Ӧ](structure-applications.md#application-configurations)  [[yii\base\Application::components]]  .
磺
Application components can be any objects. You can register them by configuring
the [[yii\base\Application::components]] property in [application configurations](structure-applications.md#application-configurations).
For example,

```php
[
    'components' => [
        // ʹע "cache" 
        'cache' => 'yii\caching\ApcCache',

        // ʹע "db" 
        'db' => [
            'class' => 'yii\db\Connection',
            'dsn' => 'mysql:host=localhost;dbname=demo',
            'username' => 'root',
            'password' => '',
        ],

        // ʹúע"search" 
        'search' => function () {
            return new app\components\SolrService;
        },
    ],
]
```

> 䣺ע̫ӦӦȫֱʹ̫ܼӴԺάѶȡ
  һ¿Ҫʱٴ
> Info: While you can register as many application components as you want, you should do this judiciously.
  Application components are like global variables. Using too many application components can potentially
  make your code harder to test and maintain. In many cases, you can simply create a local component
  and use it when needed.


##  <a name="bootstrapping-components"></a>
## Bootstrapping Components <a name="bootstrapping-components"></a>

ᵽһӦֻڵһηʱʵûзʵĻͲʵ
ʱÿ̶ʵĳᱻʣ
ԽID뵽Ӧ [[yii\base\Application::bootstrap|bootstrap]] С
As mentioned above, an application component will only be instantiated when it is being accessed the first time.
If it is not accessed at all during a request, it will not be instantiated. Sometimes, however, you may want
to instantiate an application component for every request, even if it is not explicitly accessed.
To do so, you may list its ID in the [[yii\base\Application::bootstrap|bootstrap]] property of the application.

, µӦñ֤ `log` һֱء
For example, the following application configuration makes sure the `log` component is always loaded:

```php
[
    'bootstrap' => [
        'log',
    ],
    'components' => [
        'log' => [
            // "log" 
        ],
    ],
]
```


## Ӧ <a name="core-application-components"></a>
## Core Application Components <a name="core-application-components"></a>

Yii һ̶IDĬõ **  [[yii\web\Application::request|request]] ռû󲢽 [·](runtime-routing.md)
[[yii\base\Application::db|db]] һִݿݿӡ
ͨЩYiiӦܴû
Yii defines a set of *core* application components with fixed IDs and default configurations. For example,
the [[yii\web\Application::request|request]] component is used to collect information about
a user request and resolve it into a [route](runtime-routing.md); the [[yii\base\Application::db|db]]
component represents a database connection through which you can perform database queries.
It is with help of these core application components that Yii applications are able to handle user requests.

ԤĺӦбԺͨӦһúԶǡ
һָĻͻʹYiiĬָࡣ
Below is the list of the predefined core application components. You may configure and customize them
like you do with normal application components. When you are configuring a core application component,
if you do not specify its class, the default one will be used.

* [[yii\web\AssetManager|assetManager]]: ԴԴο [Դ](output-assets.md) һڡ
* [[yii\db\Connection|db]]: һִݿݿӣ
  עøʱָԣ[[yii\db\Connection::dsn]]
  ο [ݷʶ](db-dao.md) һڡ
* [[yii\base\Application::errorHandler|errorHandler]]:  PHP 쳣
  ο [](tutorial-handling-errors.md) һڡ
* [[yii\i18n\Formatter|formatter]]: ʽʾնûݣֿҪָ
  ʹóʽο [ʽ](output-formatting.md) һڡ
* [[yii\i18n\I18N|i18n]]: ֧Ϣ͸ʽο [ʻ](tutorial-i18n.md) һڡ
* [[yii\log\Dispatcher|log]]: ־ο [־](tutorial-logging.md) һڡ
* [[yii\swiftmailer\Mailer|mail]]: ֧ʼṹͣο [ʼ](tutorial-mailing.md) һڡ
* [[yii\base\Application::response|response]]: ͸ûӦ
  ο [Ӧ](runtime-responses.md) һڡ
* [[yii\base\Application::request|request]]: նûյ
  ο [](runtime-requests.md) һڡ
* [[yii\web\Session|session]]: ỰϢ[[yii\web\Application|Web applications]] ҳӦпã
  ο [Sessions (Ự) and Cookies](runtime-sessions-cookies.md) һڡ
* [[yii\web\UrlManager|urlManager]]: ֧URLַʹ
  ο [URL ](runtime-url-handling.md) һڡ
* [[yii\web\User|user]]: ֤¼ûϢ[[yii\web\Application|Web applications]] ҳӦпã
  ο [֤](security-authentication.md) һڡ
* [[yii\web\View|view]]: ֧Ⱦͼο [Views](structure-views.md) һڡ
